# ITPM Übungsgruppe - Meeting 1

## Agenda
- [x] Define Artifacts to create
- [x] Define Tasks to do clearly
- [x] Distribute Tasks
- [x] Plan next meeting


## Artifacts

- Filled-In Table
- Presentation
    - Writeup of all arguments 

## Tasks

- Argument Collection
    - "Distributed" Brainstorming
- Presentation Creation
    - Graphics
        - Storyboard
            - Argument Collection (link)

## Until the next meeting

- Collect arguments individually
    - General Priority of Tasks
    - Risks associated with a task
    - General Ranking Idea
- Refer to the PDF for arguments
- Next meeting: Collect Arguments


## When?

Mon
17:00 - 18:00 ([Online](https://meet.jit.si/itpm-casestudy-4026495))

# Meeting 2


```mermaid
flowchart LR;
    subgraph g
    customer("customer (company) - our role") --- dev
    end g
    g --> webshop 
```

```rust
fn add(a: i32, b: i32) {
    a + b
}

#[cfg(test)]
mod test{
    use super::*;
    
    #[test]
    fn test_add() {
        assert_eq!(add(3, 5), 8);
    }

}
```

## Agenda

- [x] Feature-by-Feature - Collect Ideas
    - [x] Dependent Features / Feature-Groups

### Feature-by-Feature
+ to +++ (max)

- Product Title Display (++)
    - Essential function of the Webshop
    - Should be prioritized maximally
        - lower than pictures because fashion brand, but still high
        - Potentially Filtering based on pictures?
    - People search for names
        - Search Functionality fulfills filter functionality
- Product Page Picture and Alternate Views Display (+++)
    - Very important for purchase decision
    - essential in increasing marketability of the products
    - strongly connected with the title display
    - Loading Time / Optimization needs to be prioritized (dep?)
- Pricing information (+++)
    - Core Feature
- Testing Accuracy Increase (++ to +++)
    - Previous test runs showed many problems
        - Good reason to prioritize better testing
    - As early as possible, to prevent divergence of system architecture
        - Focus on testability in architecture if postponed
- Webshop - Page Speed Increase (+ from a time perspective)
    - \> 25% leave the page if people leave the page
    - important, but should be done at the end
- Product Quantity (+)
    - Putting multiple things in the cart works too (spam-clicking)
    - Additional Feature
- Add to cart function (+++)
    - Core Feature
    - Customers normally order multiple things at the same time from Fashion Brands
        - Increase Sale Volume
- Product Description Display (++)
    - Equivalent to Product Title Display priority-wise
    - Possible disclosure of materials / allergens mandatory?
        - Production Process (fairness, country) is important for many customers
            - => Marketability
- Product Star Review / Ranking (+)
    - Reference Values are important for new customers
        - Other people's preferences have an important influence on the customer
    - Instagram Ads / Community Presence might be important to consider
    - Not necessarily important, because lots of people have different opinions
        - Possible alternative of the fit
            - Smaller as the size / Bigger as the size
    - Contra: Star Reviews on your own page might discourage people from buying products with low reviews
        - => lower sales
- Consumer reviews on product (0 to +)
    - Same idea as above
    - Dependent on Star Review
    - Very expensive (points) to develop
- Trust Signals (++)
    - Cheap to implement and efficient
    - Important for a customer when buying on a small website
        - Needs to be done properly (clickable badge)
- Product Variables Overview (+++)
    - Core Feature
    - Need to have clothing size selection to buy this
- Product Page View Different colors (++)
    - Quite important
    - Dependent on **Product Variables Overview**
- Social Share Buttons (+ for current cost, ++ for less points)
    - Way too expensive! (ask the team to check this again? use an SDK instead?)
    - Fairly important
        - Marketing is over Instagram
        - Community validation leads to credibility
    - Need to include picture / link of the product
        - Hashtag?
- Add to wishlist function (+)
    - Low Product Volume, so not many choices
        - Maybe notification for sales?
        - Otherwise not very important
- Add to comparison function (0 to +)
    - Not that important in clothes
        - No specs to compare (e.g. processors in tech stuff)
        - How comparable are T-Shirts?
        - Similar fabric and products
- Related products (++)
    - Really good for the cost of 6 points
    - Increase Browsing Time
        - Cross-Sell-Ability
        - Customers like looking at many clothes
            - Closer to the In-Person Mall experience
            - Ikea-Effect
- Enable English language (++ to +++)
    - High priority
        - Increase Customer Base
        - Include local people who don't necessarily know the local language well
    - Delivery Costs?
- Live-Chat (0)
    - Super-low priority
    - Few users
    - Really expensive
    - Can be implemented after launch
    - Need to have resources to keep this running
    - Just a fancy (and really expensive) FAQ

## Next time (prepare)

- [ ] Group Features
    - Group by dependencies
    - "Thematische Gruppe"
- [ ] Prioritize Feature Groups
- [ ] Total Capacity / Testing Capacity
    - [ ] Sprint Planning (from / to)
    - [ ] Sprint Assignment (rough / we'll do it live)

### Next sprint date

Sa

10:00 - 12:00

So / Mo as emergency puffer



# Meeting 2

## Agenda

- [ ] Group Features
    - Group by dependencies
    - "Thematische Gruppe"
- [ ] Prioritize Feature Groups
- [ ] Total Capacity / Testing Capacity
    - [ ] Sprint Planning (from / to)
    - [ ] Sprint Assignment (rough / we'll do it live)

## Feature Groups

- Language / Localization (5P) (2+) (avg 2+)
    - Enable English language (++) (5P)
        - Later than other features because dependencies
- Product Display (21P) (10+) (avg 2.5+) 
    - Core (14P) (6+) (avg 3+)
        - Pricing information (+++) (6P)
        - Product Page Picture and Alternate Views Display (+++) (8P)
    - Bonus (7P) (4+) (avg 2+)
        - Product Title Display (++) (3P)
        - Product Description Display (++) (4P)
- Testing (14P) (3+) (avg 3+)
    - Testing Accuracy Increase (+++) (14P)
        - Directly at the start
- Optimization (12P) (1+) (avg 1+)
    - Webshop - Page Speed Increase (+ from a time perspective) (12P)
        - At the end
- Webshop Features (96P)  (11+) (avg)
    - Core(16P) (6+) (avg 3+)
        - Add to cart function (+++)(10P)
        - Product Variables Overview (+++) (6P)
    - Bonus (80P) (9+) (avg 8/7+ ($\approx 1$))
        - Product Quantity (6P) (+)
        - Add to comparison function (8P)(0)
        - Related products (6P) (++)
        - Product Page View Different colors (7P) (++)
        - Add to wishlist function (6P) (+)
        - Reviews (20P)(1+) (avg 1/2+)
            - Product Star Review / Ranking (8P) (+)
            - Consumer reviews on product (12P) (0)
        - Support (27P) (0+) (avg 0+)
            - Live-Chat (0) (27P)
- PR / Interaction (25P) (4+) (avg 2+)
    - Social Share Buttons (+ for current cost, ++ for less points)(22P)
    - Trust Signals (++) (3P)


// TODO
```mermaid
flowchart TD;
    subgraph prod[Product Display]
        prod_pr1["Pricing information (+++)"]
        prod_pr2["Product Page Picture and Alternate Views Display (+++)"]
    end prod
```
// END TODO

### Constraints

```yaml
Testing Accuracy:
    - needs to be done early
    - everything "depends" on this
Page Speed:
    - depends on everything
    - needs to be done last
Product Page View Different colors:
    - depends on "Product Page Picture and Alternate Views Display"
    - depends on "Product Variables Overview"
Add to Cart:
    - depends on "Pricing Information"
Add to Comparison Function:
    - depends on "Pricing Information"
Consumer reviews on product:
    - depends on "Star Review"
Related Products:
    - delay of 2 sprints
```

- Optimization (12P) (1+) (avg 1+)
    - Webshop - Page Speed Increase (+ from a time perspective) (12P)
        - At the end
- Webshop Features (96P)  (11+) (avg)
    - Bonus (80P) (9+) (avg 8/7+ ($\approx 1$))
        
        - Add to comparison function (8P)(0)
        
        
        - Support (27P) (0+) (avg 0+)
            - Live-Chat (0) (27P)

(maximum load capacity of 85%)

### Capacity

```yaml
S1: 
    cap: 36
    tasks:
        - Testing Accuracy Increase (14P) (focus on test-driven development)
        - Pricing information (+++) (6P)
        - Product Page Picture and Alternate Views Display (+++) (8P)
        - Product Variables Overview (+++) (6P)
    load_capacity: 94%
    
    
S2: 
    cap: 32
    tasks:
        - Add to cart function (+++)(10P)
        - Product Quantity (6P) (+)
        - Product Title Display (++) (3P)
        - Product Description Display (++) (4P)
        - Enable English Language (first half) (3P)
    load_capacity: approx 81%
    
S3: 
    cap: 31
    tasks:
        - Social Share Buttons (+ for current cost, ++ for less points) (22P)
        - Trust Signals (first part) (++) (3P)
    load_capacity: 80%
S4: 
    cap: 29
    tasks:
        - Related products (6P)
        - Product Page View Different colors (7P)
        - Add to comparison function (8P)(0)
        - Add to wishlist function (6P) (+)
    load_capacity: 93%
S5: 
    cap: 25
    tasks:
        - Product Star Review / Ranking (8P) (+)
        - Consumer reviews on product (12P) (0)
        - Webshop - Page Speed Increase (first part) (5P)
    load_capacity: 100%
S6: 
    cap: 36
    tasks:
        - Webshop - Page Speed Increase (second part) (7P)
        - Live-Chat (0) (27P)
        - Enable English Language (second half) (2P)
    load_capacity: 100%

cap sum: 189
```

## Last Meeting

### Next meeting date

So

~ 10:00 Uhr

### Agenda

- [x] Risks
- [x] Risk Mitigation
- [x] Testing Capacity?
- [x] Presentation

# Meeting 4

## Risks



- Full Capacity Sprints at the end
    - Illness / Lower-than-expected efficiency will cause features to be delayed
    - Mitigation: Low-Priority Features reduce impact of potential delays
- Improperly done Testing Accuracy Increase might cause major problems down the line
    - Architecture / Development Process Change ("Normal" Development -> Test-driven Development)
- Important Features (Page Speed Increase, English Language) at the end, so they might not be completed
    - Mitigation: Irrelevant feature Live Chat at the end, so that it may be sacrificed for the more important features if the time isn't enough
- "Related Products"-Algorithm might very well take longer than expected
    - Mitigation: Fourth Sprint, so that a One-Sprint Delay won't impact the schedule
- A subpar implementation of all picture-related tasks might impact site loading times negatively
    - Mitigation: Standardize Image Resolution to a reasonable level, Page Speed Increase at the end so that problems can be found then
- Feature Size might be wrongly estimated
    - Mitigation: Non-full capacity sprints at the start, big but irrelevant feature "Chatbot" at the end as a kind of buffer
- Effort to implement Social Share Buttons is probably heavily overestimated
    - No mitigation necessary, as it might free up some time to be done earlier on
- Improper Test Cases
    - No mitigation possible

.
.
.
.
.
.
.
.
. 
.
.
.
.
.
.
.
.
.
.
.
.
.
.
.
.
.
.
